function [j] = PlotBox(data,LabelIndex,feature_labels,normalize,type_of_color_map,shorten_labels,numbers)
%resetovn osy z dvodu funknosti
cla reset;

%% Test zda NaN
% przdn error hlen
message = [];
% pokud nebude slovn, tak xlabel bude []
XLABEL = [];

erase_vector = any(isnan(cell2mat(data)));
if any(erase_vector)
% prohledn bunk a nleit odstrann sloupc, kde se NaN nachz, se
% stejnm dopadem na feature_labels
% to mi d informaci, zda v njakm sloupci je nan
data(:,erase_vector) = [];
feature_labels(:,erase_vector) = [];

% pprava informace, kde byly vymazny data
num_vector = 1:size(erase_vector,2);
num_vector(:,~erase_vector) = [];

% v ppad NaN vyle warning, e byly odstranny sloupce
% message = ['Nkter sloupce [' num2str(num_vector) '] obsahovaly NaN a byly odstranny.'];
message = ['Some columns [' num2str(num_vector) '] contained NaN and were deleted.'];

% pokud po odstrann sloupc jsou data przdn nastane error
if isempty(data)
%     message_error = 'Nelze vykreslit boxplot. Vstupn data byla smazna. Pro zobrazen grafu vypnte normalizaci.';
    message_error = 'The Box plot was not drawn. Input data were deleted. For visualization turn off normalization.';
    warndlg([message message_error],'Warning - Boxplot');
    warning([message message_error]);
    error([message message_error]);
end

% nenastal error ale dolo k vymazn slooupc/ce
warning(message);
end


%% prava dat pro fci aboxplot
% v jedn buce na dku jsou pak vechny sloupce, ale jen pro dan tag
% (HC,PD ...)
% barevn jsou pak stejn, ale jsou vykresleny vdy pro konkrtn X
% parametr
BOX = cell(size(data,1),1);
for j = 1:size(data,1)
    BOX{j,1} = cell2mat(data(j,:));    
end

% Pipraven palety barev
if size(data,1) ~= 1
    % barevn rozdlen box dle tag
    mapa = brewermap(size(data,1),type_of_color_map);
else
    % kad label m vlastn barvu - neexistuj skupiny
    switch size(data,2)
        case 1
        % vykreslujeme jen jeden box
        mapa = [rand(1) rand(1) rand(1)];
        otherwise
        % vykreslujeme vce box  a dokreslen se provede jinak
        mapa_ver_2 = brewermap(size(data,2),type_of_color_map);
        % touto barvou pak bude vykreslen puntk prmru a prvn box
        mapa = mapa_ver_2(1,:);
    end
end


%% Uprava feature_labels pro zobrazen bez pekryt
if shorten_labels
new_feature_labels = cell(1,size(feature_labels,2));
for i = 1:size(feature_labels,2)
    % rodlen na slova
    [match_words, index_words] = regexp(feature_labels{1,i}, '\w*','match');
    % slova kter zanaj velkm psmenem jsou dleit
    [match_upper_case, index_upper_case] = regexp(feature_labels{1,i}, '[A-Z]\w+','match');
    
    % feature_label se bude upravovat pouze pokud dan buka obsahuje vce
    % jak 4 slova
    if size(match_words,2) > 4
    % vyberou se pouze 2 prvn a dv posledn slova
%     match_words = {match_words{1,1}, match_words{1,2}, match_words{1,end-1}, match_words{1,end}};
%     index_words = [index_words(1,1), index_words(1,2), index_words(1,end-1), index_words(1,end)];
    % vybe se pouze prvn a posledn slovo
    match_words = {match_words{1,1}, match_words{1,end}};
    index_words = [index_words(1,1), index_words(1,end)];
    switch size(index_upper_case,2)
        case 0
        otherwise
        % zjist se, zda slova, kter zanaj velkm psmenem u nhodou
        % nejsou vybrna
        for k =1:size(index_upper_case,2) 
            if any(index_words == index_upper_case(1,k))
                % pokud se tam nkde vyskytuje, tak se nastav log false
                index_upper_case(1,k) = 0;
            end
        end
    end
    % 0 = false, vechno ostatn true
    index_upper_case = logical(index_upper_case);
    new_feature_labels{1,i} = strjoin([...
        match_words(1,1),...
        match_upper_case(index_upper_case),...
        match_words(1,end)...
        ],'~');
    else    
    % buka obsahuje pijateln poet slov
    new_feature_labels{1,i} = feature_labels{1,i};
    end  
end
% kvli voln ve fci aboxplot
feature_labels = new_feature_labels;
end
%% ------------------------------------------------------------------------

%% Volba pro slovn msto nzv
% kompaktn zobrazen, sla se pak daj dohledat v tabulce buffer
if numbers
    feature_labels = 1:size(erase_vector,2);
    feature_labels(erase_vector) = [];
end

%% Fce Aboxplot
aboxplot(...
    BOX,...
    'colormap',mapa,...
    'Labels',feature_labels,...
    'outliermarker','+',...
    'outliermarkersize',10,...
    'outliermarkerfacecolor', mapa(1,:),...
    'outliermarkeredgecolor', mapa(1,:));

% Legenda - jen v ppad, e je vce tag
if (size(LabelIndex,1) ~= 1)
    legend(LabelIndex(:,1));
end

% pokud nejsou vcerozmrn data, je teba dobarvit jednotliv boxy znovu
% a zrove pokud pokud neexistuje pouze jeden box
if (size(LabelIndex,1) == 1) && (size(data,2) ~= 1)
    handle_rec = findobj(gcf,'Type','rectangle');
    handle_mar = findobj(gcf,'Type','Line','Marker','o');
    for j = 1:size(handle_rec,1)
        set(handle_rec(size(handle_rec,1)-j+1),'FaceColor',mapa_ver_2(j,:));
        set(handle_mar(size(handle_rec,1)-j+1),'MarkerFaceColor',mapa_ver_2(j,:));
    end
end


%% Nastaven os
title('Box plot');
YLABEL = 'Data';

if normalize
    YLABEL = [YLABEL ' (normalized)'];
end
% pokud je nastaveno slovn, tak bude popisek, jinak []
if numbers
    XLABEL = 'Input number';
end

ylabel(YLABEL);
xlabel(XLABEL);
% Zmna rozsahu osy Y pro pehlednost
my_y = get(gca,'YLim');
set(gca,'YLim',[(my_y(1,1)-range(my_y)/10) (my_y(1,2)+range(my_y)/10)]);

grid on;    