function [i] = CorrelationPlot(feat_cell,input_intervals,fit_order,version,show_reg_line,normalize,buffer,type_of_color_map)
%% Korelan graf
% m u tch plncch funkc nezajmaj dn TAGS labely, pouze ty, co si
% mu vybrat, TAGS jsou dan 'genericky' nebo vektorem vdy stejnm pro
% vechny dky
% 1 dek je X a druh dek je Y na correlation grafu
% tento zpis je vdy nutn, ControllAllLabels vrac vhodn vektor dle dat  je vdy nutn!!!

options.fit_order = fit_order;
options.intervals = input_intervals;
options.version = version;
options.show_reg_line = show_reg_line;

options.markersize = 8;
options.line_width = 2;
options.function = @linspace;
options.Spearman = 'Spearman';
options.Pearson = 'Pearson';

reg_legend = cell(0,0);
lowLevel = 1; 
highLevel = size(feat_cell,2);

%% Vytvoen mapy barev
% vhodn vbr palety barev dle potu kivek
SIZE = size(feat_cell,2)*options.intervals;
if SIZE <= 29
%   map1 = brewermap(8,'Accent');
    map2 = brewermap(8,'Dark2');
    map3 = brewermap(12,'Paired');
    map4 = brewermap(9,'Set1');
%   map5 = brewermap(8,'Set2');
%   map6 = brewermap(12,'Set3');
    map = [map4; map2; map3;];
else
    map = brewermap((size(feat_cell,2)*options.intervals),type_of_color_map);
end

%% Vytvoen databze tloutk marker dle zvolen verze vykreslovn
% line width
LW = cell(1,options.intervals);
LW(:) = {1};
switch options.version
    % verze 1 - tlouky se nestdaj
    case 1
        LS ={'+' 's' 'o' '^' '.' 'p' 'x' '>' '<' 'h' '*' 'd' 'v'};
        
    % verze 2 - jednotliv tloukz se budou stdat
    case 2
        for i = 1:options.intervals
            if mod(i,2) == 0
                LW{1,i} = 3;
            end
        end
        % Vybran tipy, kter se jet dobe vykresluj
        LS ={'+' 's' 'o' '^' '>' '<' '*' 'v'};
    otherwise
        %WARNING% 
end
%% Vytvoen databze tip Marker pro plot korelace
% pro kad graf jeden tip
% LS pedstavuje tipy marker
% pokud je pouito vce sloupc, ne je poet tip marker, zanou se
% jednotliv tipy marker zase opakovat
if ((highLevel - lowLevel)+1) > size(LS,2)
    % poet label
    Size = (highLevel - lowLevel)+1;
    % zbytek po dlen
    modulo = mod(Size,size(LS,2));
    % nsobek
    multiplier = fix(Size/size(LS,2));
    
    if modulo ~= 0
        multiplier = multiplier + 1;
    end
    
    % inicializace przdn buky
    temp = cell(1,multiplier);
    for i = 0:multiplier-1
        for j = 1:size(LS,2)
            % naplnn buky opakujcmi se vzory
            temp{1,j+(i*size(LS,2))} = LS{1,j};
        end
    end
    LS = temp;    
end

%% Vytvoen databze tip ar pro tisk koivek regrese
LR = {'-' '--' ':' '-.'};
if ((highLevel - lowLevel)+1) > size(LR,2)
    Size = (highLevel - lowLevel)+1;
    modulo = mod(Size,size(LR,2));
    multiplier = fix(Size/size(LR,2));
    
    if modulo ~= 0
        multiplier = multiplier + 1;
    end
  
    temp = cell(1,multiplier);
    for i = 0:multiplier-1
        for j = 1:size(LR,2)
            % naplnn buky opakujcmi se vzory
            temp{1,j+(i*size(LR,2))} = LR{1,j};
        end
    end
    LR = temp;    
end

%% Zskn dat pro Correlation Graf
for i = lowLevel:highLevel
    % NORMALIZACE
    % nem vliv na vsledn hodnoty regrese
    if normalize
        feat_cell{1,i} = (feat_cell{1,i} - mean(feat_cell{1,i}))/std(feat_cell{1,i});
        feat_cell{3,i} = (feat_cell{3,i} - mean(feat_cell{3,i}))/std(feat_cell{3,i});
    end
    % kontrola po normalizaci
    if ~(isempty(find( isnan(feat_cell{1,i}) == 1 )) && isempty(find( isnan(feat_cell{3,i}) == 1 )))
        message = ['Graph number ' num2str(i) ') contains NaN. Turn off the normalization.'];
        warning(message);
        warndlg(message,'Warning - Correlation');
        error(message);
    end
    [r, p1] = corr(feat_cell{1,i}, feat_cell{3,i}, 'type', options.Pearson);
    [p, p2] = corr(feat_cell{1,i}, feat_cell{3,i}, 'type', options.Spearman);
    r = round(r*1e4)/1e4;
    p1 = round(p1*1e4)/1e4;
    p = round(p*1e4)/1e4;
    p2 = round(p2*1e4)/1e4;
    % BARVY 5 dek - poet barev dle interval - bere to z t matice po
    % dcch
    feat_cell{5,i} = map((((i*options.intervals)-options.intervals)+1):(i*options.intervals),:);
    % PEARSON 6 dek + spolehlivost
    feat_cell{6,i} = [r p1];
    % SPEARMAN 7 dek + spolehlivost
    feat_cell{7,i} = [p p2];
    % REGRESNI KRIVKA 8 dek zvoleneho radu
    feat_cell{8,i} = polyfit(feat_cell{1,i}, feat_cell{3,i}, options.fit_order);
    % MATICE ROZDELENYCH DAT 9 dek - matice
    [split_cell, intervals] = split_data(feat_cell{3,i}, options.intervals, options.function);
    feat_cell{9,i} = split_cell;
    % MATICE ROZDELENYCH DAT 10 dek - intervaly
    feat_cell{10,i} = intervals;
    % VEKTOR TAGU pro osu x 11 dek
    feat_cell{11,i} = strjoin([num2str(i) ')' feat_cell{2,i}]);
    % VEKTOR TAGU pro osu y 12 dek
    feat_cell{12,i} = strjoin([num2str(i) ')' feat_cell{4,i}]);
    % VEKTOR TAGU pro Spearmana 13 dek
    feat_cell{13,i} = [num2str(i) ') r = ' num2str(feat_cell{7,i}(1,1)) ', {\itp} = ' num2str(feat_cell{7,i}(1,2)) ...
        ', ' num2str(options.fit_order) '. order fit'];    
    % VEKTOR TAGU pro Pearsona 14 dek
    feat_cell{14,i} = [num2str(i) ') \rho = ' num2str(feat_cell{6,i}(1,1)) ', {\itp} = ' num2str(feat_cell{6,i}(1,2)) ...
        ', ' num2str(options.fit_order) '. order fit'];
    % VEKTOR TAGU Pearson & Spearman dohromady 15 dek
    feat_cell{15,i} = [num2str(i) ') r = ' num2str(feat_cell{7,i}(1,1)) ', {\itp} = ' num2str(feat_cell{7,i}(1,2)) '; '...
                                       '\rho = ' num2str(feat_cell{6,i}(1,1)) ', {\itp} = ' num2str(feat_cell{6,i}(1,2))];
    % VEKTOR TAGU Pearson & Spearman dohromady 16 dek spolu s regresn
    % kivkou
    feat_cell{16,i} = [feat_cell{15,i} ', ' num2str(options.fit_order) '. fit order'];
    
    % Vykreslen grafu
    for j = 1:options.intervals
        dat = feat_cell{9,i}(:,(options.intervals-j)+1);
        % vykresluje se to naopak, aby poad v legend odpovdalo ose y
        % barvy se vykresluj inkrementln - to nem vliv a markery taky
        plot(feat_cell{1,i}(dat), feat_cell{3,i}(dat), LS{1,i}, 'color', feat_cell{5,i}(j,:),'markers', ...
            options.markersize,'LineStyle','none', 'LineWidth', LW{1,j});
        % jednotliv grafy budou rozpoznny dle sla
        corr_legend{((options.intervals*(i-1))+j)} = [num2str(i) '. graphs data from <' num2str(feat_cell{10,i}(1,(options.intervals-j)+1)) ', ' num2str(feat_cell{10,i}(1,((options.intervals-j)+1)+1)) ')']; 
        hold on;
    end
end
% zskan handles na nynj graf
corr_object = gca;

%% Vykreslen regresivnch kivek
% barva bude dna tipem vykreslen(version) z dvodu pehlednosti
if options.show_reg_line
for i = lowLevel:highLevel
    % verze 1 - vykresluje se prvn barvou z pouit palety
    if (options.version == 1) 
        COLOR = feat_cell{5,i}(1,:);
    else
        switch options.intervals
            case 1
                COLOR = feat_cell{5,i}(1,:);
            otherwise
                % verze 2 - vykresluje se druhou barvou z pouit palety
                % protoe sud intervaly jsou tlustmy body vykresleny
                COLOR = feat_cell{5,i}(2,:);
        end
    end
    % popisek kivkz bude nkde na 1/10 kivky na X hodnot
    set(refcurve(feat_cell{8,i}),'LineStyle',LR{i}, 'Color', COLOR, 'LineWidth', options.line_width);
    reg_legend{i} = [num2str(i) ')' ' regression line'];
end
end
%% NZEV
title(feat_cell(16,:));

%% LEGENDA
legend(corr_object, [corr_legend reg_legend]);

%% Uprava pehlednosti os X a Y
% pokud k vykresleni vce graf byly pouity napklad stejn data pro X,
% tak se vykresl pouze popisek jednou
temp_cell = cell(1,size(feat_cell,2));
temp_cell(:) = feat_cell(2,1);
indX = all(cellfun(@strcmp, feat_cell(2,:), temp_cell(1,:)));
temp_cell(:) = feat_cell(4,1);
indY = all(cellfun(@strcmp, feat_cell(4,:), temp_cell(1,:)));
if indX
    resultX = feat_cell{2,1};
else
    resultX = feat_cell(11,:);
end
% zaveden informace o normalizaci - osa X
if normalize
    resultX = [resultX '(normalized)'];
end
xlabel(resultX);

if indY
    resultY = feat_cell{4,1};
else
    resultY = feat_cell(12,:);
end
% zaveden informace o normalizaci - osa Y
if normalize
    resultY = [resultY '(normalized)'];
end
ylabel(resultY);

axis tight; 
grid on;
hold off;