function [feat_cell] = AfterPickFiller4Corr(buffer,feat_matrix,feature_labels,labels,labels_names)
% jedna se o funkci ktera zpracovava data pro korelacni graf, rozdeluje
% data do bunek, kdy v kazdem sloupci jsou informace pro dane vykresleni,
% oekv na vstupu:
% 1*buffer - 2*X matrix 
% 2*feat_matrix - numbers
% 3*feature_labels - 'string'
% 4*labels - 'numbers'
% 5*labels_names - 'string'
% vystupem je feat_cell, ktera obsahuje uz zpracovane data
% v labels a labes names uz nesmi byt chary!!!!
% muze zpracovavat v jednom grafu jak labels s feat matrix, tak naopak,
% nebo i treba labels labels nebo matrix matrix
% je dulezite aby pocet sloupcu z bufferu byl roven sudemu poctu, jelikoz
% korelacni graf vykresluje vdy data proti sobe
con.all = 'all';
con.cor = 'cor';
con.feat_m = true;
con.labels = false;
% upravuje data dle zvolench hodnot, jeliko uivatel si to me zvolit
% jak chce
%% promenne
ERROR = false;
message.error = 'Empty error.';
message.ErEven = 'The sum of chosen columns have to be odd number. Check one more or uncheck one column. ';
message.ok = ':) Preparation data for correlation plot ...';
% message.ok = ' :) Provadime pripravu dat pro korelaci';
message.ErZero = 'You have to choose at least 2 columns of data to diplay correlation graph. You had chosen none.';
message.ErOne = 'You have to choose at least 2 columns of data to diplay correlation graph. You had chosen only one.';

%% Kontrola velikosti - potu sloupc vektoru bufferu
if size(buffer,2) == 0
    ERROR = true;
    message.error = message.ErZero;
end

if size(buffer,2) == 1
    ERROR = true;
    message.error = message.ErOne;
end

% tato podmnka se vyvol pouze pokud jet njak error nenastal
if (mod(size(buffer,2),2) ~= 0) && ~ERROR
    ERROR = true;
    message.error = message.ErEven;
end

%% Nasypn dat
% probhne pokud negovan Error bude true

% 1*feat_matrix - numbers
% 2*feature_labels
% 3*labels
% 4*labels_names
if ~ERROR
    warning(message.ok);
    feat_cell = cell(4,(size(buffer,2)/2));
    j = 1;
    i = 1;
    % vdy se bere dvojice z bufferu a zapisuje se to do jedn pkn
    % dkov buky
    while i < (size(buffer,2)+1);
        % je to feat_matrix
        if buffer{1,i}
            feat_cell{1,j} = feat_matrix(:,buffer{2,i});
            feat_cell{2,j} = feature_labels(1,buffer{2,i});
        % je to labels
        else
            feat_cell{1,j} = cell2mat(labels(:,buffer{2,i}));
            feat_cell{2,j} = labels_names(1,buffer{2,i});   
        end
        
        % druh je taky feat_matrix
        if buffer{1,i+1}
            feat_cell{3,j} = feat_matrix(:,buffer{2,i+1});
            feat_cell{4,j} = feature_labels(1,buffer{2,i+1});
        % je to labels
        else
            feat_cell{3,j} = cell2mat(labels(:,buffer{2,i+1}));
            feat_cell{4,j} = labels_names(1,buffer{2,i+1});
        end
        % dal sloupec ve vsledn buce
        j = j + 1;
        % zpsob posun na i+2 polko v bufferu
        i = i + 2;
    end
else    
    warning(message.error);
    warndlg(message.error,'Warning - Error loading data');    
    error(message.error);
end
%% testovn
% all(cell2mat(feat_cell{3,5}) == cell2mat(labels(:,1))) - napklad