function TypeOfLabelsData = CheckMyData(feat_matrix,feature_labels,labels,labels_names)
% Funkce poze kontroluje vstupn data tak jak jsou,  nijak data neovlivuje neparsuje
% Vstupem je dkov buka s tipy jednotlivch sloupc labels
% feat_matrix       -  vstupn matice
% feature_labels    -  jednodkov vektor popisk namench dat
% labels            -  labely dat tipu char nebo double, jejich kombinace
%                      v jednom sloupci nen mon
% TypeOfLabelsData  -  Vstupn buka s tipy label(char/number)
% Vypn program, pokud nastane na teto urovni chyba

%% Vstupn promnne
% message vstupn zprva
% ER ptomnost erroru
% TypeOfLabelsData - logick buka pro kontrolu konzistence buky labels
% Columns error columns
message = ['Loaded data are ok.'];
constant.number = 'Number ';
constant.char = 'Char ';
ER = false;
CheckMatrix = false(size(labels,1),size(labels,2));
TypeOfLabelsData = cell(1,size(labels,2));
columns = [];

%% Kontrola rozsah vstupnch dat
if (size(feat_matrix,1) ~= size(labels,1))
    message = ['Size of rows of feat_matrix and labels does not match.'];
    ER = true;
end    

if (size(feat_matrix,2) ~= size(feature_labels,2))
    message = ['Size of columns of feat_matrix and feature_labels doe not match.'];
    ER = true;
end

if (size(feature_labels,1) ~= 1)
    message = ['The feature_labels cell can have only one row.'];
    ER = true;
end

if (size(labels_names,2) ~= size(labels,2))
    message = ['The number of columns in labels_name and labels is not same.'];
    ER = true;
end

if (size(labels_names,1) ~= 1)
    message = ['The labes_names cell can have only one row.'];
    ER = true;
end
% EMPTY CELLS OR MATRICIES - they are on end, becouse they have higher
% information value, so with their notification will be the message
% rewrited
if (size(feat_matrix,2) == 0) || isempty(feat_matrix)
    message = ['feat_matrix is empty.'];
    ER = true;
end

if (size(feature_labels,2) == 0) || any(any(cellfun(@isempty,feature_labels)))
    message = ['feature_labels is empty.'];
    ER = true;
end

if (size(labels,2) == 0) || any(any(cellfun(@isempty,labels)))
    message = ['labels is empty.'];
    ER = true;
end

if (size(labels_names,2) == 0) || any(any(cellfun(@isempty,labels_names)))
    message = ['labels_names is empty.'];
    ER = true;
end

%% Kontrola buky labels na  konzistenci uvnit sloupce
% jednotliv sloupce vak od sebe MَOU bt rozdln
%
% Nejsve je vytvoena logick matice, kter destuje labels, zda konkrtn
% hodnota je slo
for i = 1:size(labels,2)
    for j = 1:size(labels,1)
    CheckMatrix(j,i) = isnumeric(labels{j,i});
    end
end

% pot se prochz jednotliv sloupce a zjituj se stav log 1 a log 0
for i = 1:size(CheckMatrix,2)
% pokud jsou vechny 1, tak po log AND je vsledek 1
if all(CheckMatrix(:,i) == 1)
    % sam 1 odpovdaj selnmu sloupcovmu vektoru
    TypeOfLabelsData{1,i} = constant.number;
else
    % to znamen, e nkter poloka je nula, proto kdy budou vechny nuly, 
    % tak log OR bude 0 a tento vsledek negovan bude 1. V opanm ppad 
    % log OR bude 1 a negovan bude 0 a tak se dostaneme do error stavu
    if ~any(CheckMatrix(:,i) == 1)
    TypeOfLabelsData{1,i} = constant.char;
    else
    % data jsou nekonzistentn, labels se skldaj jak z char tak z sel
    ER = true;
    columns = [columns num2str(i) ','];
    message = ['Data in cell "labels" have to be numbers or chars only.' ...
        ' Columns of numbers: ' columns ' consist of more than one datatype.'];
    end
end
end

%% Vpis varovnch hlen nebo ukonen programu
if ER
    warning(message);
    warndlg(message,'Warning - CheckMyData')
    error('Program exit');
else
    message = [message ' Data in cell labels are: ' TypeOfLabelsData{:}];
    warning(message);
end
