%% MATLAB DEFINED FUNCTIONS
function varargout = GUI(varargin)
%GUI M-file for GUI.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('Property','Value',...) creates a new GUI using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to GUI_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      GUI('CALLBACK') and GUI('CALLBACK',hObject,...) call the
%      local function named CALLBACK in GUI.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help GUI

% Last Modified by GUIDE v2.5 11-May-2016 12:52:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before GUI is made visible.
function GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for GUI
handles.output = hObject;

% Visible off pro tabulky pi naten gui
set(handles.feat_matrix_table,'Visible','off');
set(handles.labels_table,'Visible','off');
set(handles.buffer_table,'Visible','off');

% Visible off axes1
set(allchild(handles.axes1),'visible','off');
set(handles.axes1,'Visible','off');

% Visible off tlatka toggle, (pole, a texty pro korelaci jsou automaticky
% inabled pomoc GUI vlastnost, spolu s ostatnmy tlatky)
set(handles.radio2_verze_scatter,'Enable','off');
set(handles.radio1_verze_scatter,'Enable','off');

%% Inicializace promnnch
% Pro vechny
handles.type_of_color_map = 'Spectral';

% Kernel density estimation
handles.plotValues_kernel = false;
handles.normalize_kernel = false;

% Scatter plot
handles.input_intervals = 3;
handles.fit_order = 1;
handles.version = 1;
handles.show_reg_line = false;
handles.normalize_scatter = false;

% Histogram
handles.normalize_histogram = false;
handles.choose_bins = 'sqrt';

% Boxplot
handles.normalize_boxplot = false;
handles.shorten_labels = false;
handles.numbers = false;

% QQplot
handles.normalize_qqplot = false;
handles.visible_reglines = false;

% PPplot
handles.normalize_pp_plot = false;
handles.visible_reglines_pp_plot = false;

% Pidn pracovnch sloek
addpath(...
    'Box_plot',...
    'Correlation_plot',...
    'Data_processing',...
    'Histogram_plot',...
    'KernelDensityEstimation_plot',...
    'PP_plot',...
    'QQ_plot',...
    'Time_series');

%---------------------------------------
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = GUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


%% USER DEFINED FUNCTIONS

%% Load Data button

function load_data_button_Callback(hObject, eventdata, handles)
[FileName,PathName] = uigetfile('*.mat','Choose *.mat file for visualization.');
if(~isequal(FileName,0))
    %% dodlat nulovn vech promnnch po novm naten
    %% Zobrazen osy
    set(allchild(handles.axes1),'visible','on'); 
    set(handles.axes1,'Visible','on');
    %% Vynulovn pedelch error
    % pokud nastane error, ztrat se jen to, co nebylo updatovan
    lastwarn('');
   
    %% Inicializace bufferu a jeho tlatek, tabulek a tlatek pro vizualizaci
    handles.buffer = [0; 0];
    set(handles.feat_matrix_table,'Data',[]);
    set(handles.labels_table,'Data',[]);
    set(handles.buffer_table,'Data', []);
    
    set(handles.feat_matrix_table,'Visible','off');
    set(handles.labels_table,'Visible','off');
    set(handles.buffer_table,'Visible','off');
    
    % pomoc tto funkce se povoluj a zakazuj vechny tlatka v gui
    handles = checkButtons(handles);
        
    %% Natn vstupnch dat
    handles.mat_file_name = [PathName FileName];
    
    temp = load(handles.mat_file_name, 'feat_matrix');
    %kontrola natench dat FEAT_MATRIX
        checkLoadWarning();
    variablenames = fieldnames(temp);
    handles.feat_matrix = temp.(variablenames{1});
    
    temp = load(handles.mat_file_name, 'feature_labels');
    %kontrola natench dat FEATURE_LABELS
        checkLoadWarning();
    variablenames = fieldnames(temp);
    handles.feature_labels = temp.(variablenames{1});
    
    temp = load(handles.mat_file_name, 'labels');
    %kontrola natench dat LABELS
        checkLoadWarning();
    variablenames = fieldnames(temp);
    handles.labels = temp.(variablenames{1});
    
    temp = load(handles.mat_file_name, 'labels_names');
    %kontrola natench dat LABELS_NAMES
        checkLoadWarning();
    variablenames = fieldnames(temp);
    handles.labels_names = temp.(variablenames{1});

    
    %% KONTROLA VSTUPNCH DAT
    handles.TypeOfLabelsData = ...
        CheckMyData( ...
        handles.feat_matrix,handles.feature_labels, handles.labels, handles.labels_names);
    %dochz zde k oddlen rznch tip dat v labels, TAGS jsou char, a
    %labels jsou sla
    [handles.labels, handles.labels_names ,handles.TAGS, handles.TAGS_NAMES ] = ...
        ControllAllLabels( ...
        handles.TypeOfLabelsData, handles.labels, handles.labels_names);
    % GetLabelIndex pro svou funkci potebuje prv jen TAGS - v ppad e
    % neexistuj dn char v pvodn naten promnn handles.labels, tak
    % se do TAGS pid sloupcov vektor teek
    handles.LabelIndex = ...
        GetLabelIndex(...
        handles.TAGS);
    
       
    %% 1D STATISTIKY
    % zskn 1D statistik pro feat matrix
    % M1 jako matrix 1D statistikz
    % *false znamen zkaz normalizace
    handles.dataM1 = ...
        LoadMatrix2Cell(...
        handles.feat_matrix, handles.LabelIndex, false);
    
    [handles.FINAL_1D_MATRIX, handles.FINAL_1D_MARIX_TAGS] = ...
        PopisneStatistiky(...
        handles.dataM1,handles.LabelIndex);
    set(handles.feat_matrix_table,...
        'Data', handles.FINAL_1D_MATRIX,...
        'ColumnName', handles.feature_labels,...
        'RowName', handles.FINAL_1D_MARIX_TAGS,...
        'ColumnWidth',{70}, ...
        'Visible','on');
    % donastaven tabulek pro buffer
    set(handles.buffer_table, ...
        'RowName', {'Source of data', 'Selected data'},...
        'ColumnWidth',{30}, ...
        'Visible','on');
    
    if isempty(handles.labels)
    %pipraveno pro njakou akci
    else
    % zskn 1D statistik pro labels
    % L1 jako labels pro 1D
    % cell2mat jeliko seln labels jsou v bukch
    handles.dataL1 = ...
        LoadMatrix2Cell(...
        cell2mat(handles.labels), handles.LabelIndex, false);
    
    [handles.FINAL_1D_LABELS, handles.FINAL_1D_LABELS_TAGS] = ...
        PopisneStatistiky(...
        handles.dataL1,handles.LabelIndex);
    
    set(handles.labels_table,...
        'Data', handles.FINAL_1D_LABELS,...
        'ColumnName', handles.labels_names,...
        'RowName', handles.FINAL_1D_LABELS_TAGS,...
        'ColumnWidth',{60},...
        'Visible','on');
    end
    %% ___________________________________________________________________%
    % vypsn cesty k souboru
    set(handles.cesta_k_souboru_field, 'String', handles.mat_file_name);
    % informace pro usera
    set(handles.Load_text,'string', 'Data loading finished.');
    
    %% Update data (pouit vade kde se pepisuje promnn handles - u vech callbacks) :
    guidata(hObject, handles);
end



%% PP plot

function pp_plot_button_Callback(hObject, eventdata, handles)
%% Funkce afterPickFiller4TheRest
% pomoc promnn buffer vytvo matici hodnot boxplot_feat_matrix a dkov
% vektor bunk kter se budou zobrazovat
[handles.pp_plot_feat_matrix,handles.pp_plot_feature_labels] = ...
    AfterPickFiller4TheRest(...
    num2cell(handles.buffer),handles.feat_matrix,handles.feature_labels,handles.labels,handles.labels_names);
%% Funkce LoadMatrix2Cell
% uprabuje data dle TAGS
% normalize je voliteln parametr
[handles.data_4_pp_plot] = ...
    LoadMatrix2Cell(...
    handles.pp_plot_feat_matrix, handles.LabelIndex, handles.normalize_pp_plot);

%% Funkce PlotPP
% function [i] = PlotPP(data,feature_labels,LabelIndex,normalize,visible_reglines,type_of_color_map)
[handles.none] = PlotPP(...
    handles.data_4_pp_plot,...
    handles.pp_plot_feature_labels,...
    handles.LabelIndex,...
    handles.normalize_pp_plot,...
    handles.visible_reglines_pp_plot,...
    handles.type_of_color_map);

set(handles.Load_text,'string', 'P-P plot is finished.');
guidata(hObject, handles);

function pp_norm_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.pp_norm_toggle,'Value');
switch stav
    case 0
    message = 'The data for P-P plot will be not normalized.';    
    handles.normalize_pp_plot = false;
    case 1
    message = 'The data for P-P plot will be normalized.';    
    handles.normalize_pp_plot = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

function pp_regline_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.pp_regline_toggle,'Value');
switch stav
    case 0
    message = 'The quartiles lines for P-P plot will be not drawn.';    
    handles.visible_reglines_pp_plot = false;
    case 1
    message = 'The quartiles lines for P-P plot will be drawn.';
    handles.visible_reglines_pp_plot = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);



%% QQ plot

function qq_plot_button_Callback(hObject, eventdata, handles)
%% Funkce afterPickFiller4TheRest
% pomoc promnn buffer vytvo matici hodnot boxplot_feat_matrix a dkov
% vektor bunk kter se budou zobrazovat
[handles.qqplot_feat_matrix,handles.qqplot_feature_labels] = ...
    AfterPickFiller4TheRest(...
    num2cell(handles.buffer),handles.feat_matrix,handles.feature_labels,handles.labels,handles.labels_names);
%% Funkce LoadMatrix2Cell
% uprabuje data dle TAGS
% normalize je voliteln parametr
[handles.data_4qqplot] = ...
    LoadMatrix2Cell(...
    handles.qqplot_feat_matrix, handles.LabelIndex, handles.normalize_qqplot);

%% Funkce plotQQ
% function [i] = plotQQ(data,LabelIndex,feature_labels,normalize,type_of_color_map,visible_reglines)
[handles.none] = plotQQ(...
    handles.data_4qqplot,...
    handles.LabelIndex,...
    handles.qqplot_feature_labels,...
    handles.normalize_qqplot,...
    handles.type_of_color_map,...
    handles.visible_reglines);

set(handles.Load_text,'string', 'Q-Q plot is finished.');
guidata(hObject, handles);

function qq_norm_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.qq_norm_toggle,'Value');
switch stav
    case 0
    message = 'Data for Q-Qplot will be not normalized.';    
    handles.normalize_qqplot = false;
    case 1
    message = 'Data for Q-Qplot will be normalized.';    
    handles.normalize_qqplot = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

function qq_regline_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.qq_regline_toggle,'Value');
switch stav
    case 0
    message = 'Regression lines for Q-Q plot will be not drawn.';    
    handles.visible_reglines = false;
    case 1
    message = 'Regression lines for Q-Q plot will be drawn.';
    handles.visible_reglines = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

    

%% Boxplot buttons

function box_plot_button_Callback(hObject, eventdata, handles)
%% Funkce afterPickFiller4TheRest
% pomoc promnn buffer vytvo matici hodnot boxplot_feat_matrix a dkov
% vektor bunk kter se budou zobrazovat
[handles.boxplot_feat_matrix,handles.boxplot_feature_labels] = ...
    AfterPickFiller4TheRest(...
    num2cell(handles.buffer),handles.feat_matrix,handles.feature_labels,handles.labels,handles.labels_names);
%% Funkce LoadMatrix2Cell
% uprabuje data dle TAGS
% normalize je voliteln parametr
[handles.data_4Boxplot] = ...
    LoadMatrix2Cell(...
    handles.boxplot_feat_matrix, handles.LabelIndex, handles.normalize_boxplot);

%% Funkce PlotBox
%[i] = PlotBox(data,LabelIndex,feature_labels,normalize,type_of_color_map,smaller_font_4_labels,shorten_labels)
[handles.none] = ...
    PlotBox(...
    handles.data_4Boxplot,...
    handles.LabelIndex,...
    handles.boxplot_feature_labels,...
    handles.normalize_boxplot,...
    handles.type_of_color_map,...
    handles.shorten_labels,...
    handles.numbers);

set(handles.Load_text,'string', 'The Box plot is finished.');
guidata(hObject, handles);

function norm_box_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.norm_box_toggle,'Value');
switch stav
    case 0
    message = 'Data for Box plot will be not normalized.';    
    handles.normalize_boxplot = false;
    case 1
    message = 'Data for Box plot will be normalized.';    
    handles.normalize_boxplot = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

function labels_box_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.labels_box_toggle,'Value');
switch stav
    case 0
    message = 'Labels for Box plot will be not shortened.';
    handles.shorten_labels = false;
    case 1
    message = 'Labels for Box plot will be shortened.';
    handles.shorten_labels = true;
end
set(handles.Load_text,'string', message);
guidata(hObject, handles);

function num_box_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.num_box_toggle,'Value');
switch stav
    case 0
    message = 'The x axes of Box plot will be not numbered.'; 
    handles.numbers = false;
    case 1
    message = 'The x axes of Box plot will be numbered.'; 
    handles.numbers = true;
end
set(handles.Load_text,'string', message);
guidata(hObject, handles);

    
    
%% Histogram buttons

function histogram_button_Callback(hObject, eventdata, handles)
% [i] = PlotHistogram(data,feature_labels,LabelIndex,normalize,choose_bins,type_of_color_map)
%[feat_matrix,feature_labels] = AfterPickFiller4TheRest(buffer,feat_matrix,feature_labels,labels,labels_names);
%% Funkce afterPickFiller4TheRest
% pomoc promnn buffer vytvo matici hodnot kernel_feat_matrix a dkov
% vektor bunk kter se budou zobrazovat
[handles.histogram_feat_matrix,handles.histogram_feature_labels] = ...
    AfterPickFiller4TheRest(...
    num2cell(handles.buffer),handles.feat_matrix,handles.feature_labels,handles.labels,handles.labels_names);
%% Funkce LoadMatrix2Cell
% uprabuje data dle TAGS
% normalize je voliteln parametr
[handles.data_4Histogram] = ...
    LoadMatrix2Cell(...
    handles.histogram_feat_matrix, handles.LabelIndex, handles.normalize_histogram);

%% Funkce Histogram
% handles.data_4Histogram ... data upraven dle bufferu
% handles.histogram_feature_labels ... popisky pro vstupn data
% handles.LabelIndex ... informace o stavu TAGS v buce labels
% handles.normalize_histogram ... informace, yda jsou data normalizovan
% handles.choose_bins = volba mezi poet binu = sqrt(poet dk), nebo
% *jakmkoliv slem, co uivatel zvol menm ne poet dk
% handles.type_of_color_map ... voliteln mapa barev
% handles.none ... pomocn random promnn
[handles.none] = ...
    PlotHistogram(...
    handles.data_4Histogram,...
    handles.histogram_feature_labels,...
    handles.LabelIndex,...
    handles.normalize_histogram,...
    handles.choose_bins,...
    handles.type_of_color_map);

set(handles.Load_text,'string', 'The Histogram plot is finished.');
guidata(hObject, handles);

function histogram_norm_toggle_Callback(hObject, eventdata, handles)
stav = get(handles.histogram_norm_toggle,'Value');
switch stav
    case 0
    message = 'Data pro Histogram nebudou normalizovna.';    
    handles.normalize_histogram = false;
    case 1
    message = 'Data pro Histogram budou normalizovna.';
    handles.normalize_histogram = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

function histogram_bins_field_Callback(hObject, eventdata, handles)
% Kontrola se provd a uvnit fce
input = get(handles.histogram_bins_field,'String');
handles.choose_bins = input;
set(handles.Load_text,'string', ['The number of bins will be ' input '.']);

guidata(hObject, handles);


% matlab funkce k vytvoen danch prvk
function histogram_bins_field_CreateFcn(hObject, eventdata, handles)
% hObject    handle to histogram_bins_field (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Kernel density buttons

function kernel_density_button_Callback(hObject, eventdata, handles)
%[feat_matrix,feature_labels] = AfterPickFiller4TheRest(buffer,feat_matrix,feature_labels,labels,labels_names);
%% Funkce afterPickFiller4TheRest
% pomoc promnn buffer vytvo matici hodnot kernel_feat_matrix a dkov
% vektor bunk kter se budou zobrazovat
[handles.kernel_feat_matrix,handles.kernel_feature_labels] = ...
    AfterPickFiller4TheRest(...
    num2cell(handles.buffer),handles.feat_matrix,handles.feature_labels,handles.labels,handles.labels_names);
%% Funkce LoadMatrix2Cell
% uprabuje data dle TAGS
% normalize je voliteln parametr
% handles.normalize_kernel = true;

[handles.data_4kernel] = ...
    LoadMatrix2Cell(...
    handles.kernel_feat_matrix, handles.LabelIndex, handles.normalize_kernel);
%% Funkce pro samotnou vizualizaci - KernelDensityEstimation
% buffer kvli velikosti
% data jsou data ovlivnn bufferem (jakoby msto feat_matrix)
% plot values - zda chci tisknout data
% feature_labels pro nov hodnoty
% LabelIndex - kvli tipm vykreslovn
% normalize - kvli informaci pro vykreslovn os

% plotValues je voliteln parametr
% handles.plotValues_kernel = true;

[handles.none] = ...
    KernelDensityEstimation(num2cell(handles.buffer),...
                            handles.data_4kernel,...
                            handles.kernel_feature_labels,...
                            handles.plotValues_kernel,...
                            handles.LabelIndex,...
                            handles.normalize_kernel,...
                            handles.type_of_color_map);
set(handles.Load_text,'string', 'Kernel density estimation plot is finished.');                        
guidata(hObject, handles);

function kernel_norm_toggle_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_norm_toggle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of kernel_norm_toggle
stav = get(handles.kernel_norm_toggle,'Value');
switch stav
    case 0
    message = 'The data for Kernel densiti estimation will be not normalized.';    
    handles.normalize_kernel = false;
    case 1
    message = 'The data for Kernel densiti estimation will be normalized.';    
    handles.normalize_kernel = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

function kernel_values_toggle_Callback(hObject, eventdata, handles)
% hObject    handle to kernel_values_toggle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of kernel_values_toggle
stav = get(handles.kernel_values_toggle,'Value');
switch stav
    case 0
    message = 'The value points for Kernel density estimation will not be drawn.';    
    handles.plotValues_kernel = false;
    case 1
    handles.plotValues_kernel = true;
    message = 'The value points for Kernel density estimation will not be drawn.';
end
set(handles.Load_text,'string', message);
guidata(hObject, handles);



%% Korelan diagram buttons
% vykreslen korelanho diagramu
function scatter_plot_button_Callback(hObject, eventdata, handles)
% Scatter plot bude fungovat pouze, pokud je v labels jen sloupcov vektor
% char, kter m tu samou hodnotu ve vech dcch, anebo nem v labels
% char vektor vbec
% prava dat pro vykreslen dle stavu bufferu
handles.scatter_feat_cell = ...
    AfterPickFiller4Corr(...
    num2cell(handles.buffer),...
    handles.feat_matrix,...
    handles.feature_labels,...
    handles.labels,...
    handles.labels_names);

%% Vizualizace Korelanho grafu - CorrelationPlot
% * handles.none je random promnn jen kvli funknosti
% * handles.scatter_feat_cell je vstupn pole bunk, pedzpracovanch
% pomoc fce AfterPickFiller4Corr
% * handles.input_intervals poet barevn rozdlujcch interval (rand)
% * handles.fit_order d regresn pmky (rand)
% * handles.version verze vykreslovn (1,2)
% * handles.show_reg_line boolean, zda vykreslit reg kivku
% * handles.normalize_scatter boolean, zda normalizovat ped

% handles.input_intervals = 3;
% handles.fit_order = 1;
% handles.version = 2;
% handles.show_reg_line = false;
% handles.normalize_scatter = false;

%function [i] = CorrelationPlot(feat_cell,input_intervals,fit_order,version,show_reg_line,normalize)
[handles.none] = ...
    CorrelationPlot(...
    handles.scatter_feat_cell,...
    handles.input_intervals,...
    handles.fit_order,...
    handles.version,...
    handles.show_reg_line,...
    handles.normalize_scatter,...
    num2cell(handles.buffer),...
    handles.type_of_color_map);

set(handles.Load_text,'string', 'Correlation plot is finished.');
guidata(hObject, handles);

% zjitn du kivky
function fit_panel_scatter_Callback(hObject, eventdata, handles)
input = str2double(get(handles.fit_panel_scatter,'String'));
if ~isnan(input)
    handles.fit_order = abs(input);
    set(handles.Load_text,'string', ['Fit order for regression line is ' num2str(input) '.']);
else
    set(handles.fit_panel_scatter,'String','1');
    handles.fit_order = 1;
    set(handles.Load_text,'string', 'Your input for order of regression fit cannot be character.');
end
guidata(hObject, handles);

% zjitn hodnoty potu interval pro korelan graf
function intervals_panel_scatter_Callback(hObject, eventdata, handles)
input = str2double(get(handles.intervals_panel_scatter,'String'));
if ~isnan(input)
    handles.input_intervals = abs(input);
    set(handles.Load_text,'string', ['Number of intervals in scatter plot will be ' num2str(input) '.']);
else
    set(handles.intervals_panel_scatter,'String','3');
    handles.input_intervals = 3;
    set(handles.Load_text,'string', 'Your input cannot be character.');
end
guidata(hObject, handles);

% zapnut/vypnut normalizace scatter plotu
function normalize_toggle_scatter_Callback(hObject, eventdata, handles)
stav = get(handles.normalize_toggle_scatter,'Value');
switch stav
    case 0
    message = 'The data for Correlation plot will be not normalized.';    
    handles.normalize_scatter = false;
    case 1
    message = 'The data for Correlation plot will be normalized.';
    handles.normalize_scatter = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

% zapnut/vypnut regresn kivky
function reg_line_toggle_scatter_Callback(hObject, eventdata, handles)
stav = get(handles.reg_line_toggle_scatter,'Value');
switch stav
    case 0
    message = 'The regression lines for Correlation plot will not be drawn.';    
    handles.show_reg_line = false;
    case 1
    message = 'The regression lines for Correlation plot will be drawn.';    
    handles.show_reg_line = true;
end

set(handles.Load_text,'string', message);
guidata(hObject, handles);

% radiobuttons callback - verze vykreslen
function verze_group_scatter_SelectionChangeFcn(hObject, eventdata, handles)
if strcmp(get(eventdata.NewValue, 'Tag'),'radio1_verze_scatter')
    handles.version = 1;
    message = 'The graphical version of Correlation plot will be number 1.';
else
    handles.version = 2;
    message = 'The graphical version of Correlation plot will be number 2.';
end
set(handles.Load_text,'string', message);
guidata(hObject, handles);



% matlab funkce k vytvoen danch prvk
function intervals_panel_scatter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to intervals_panel_scatter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function fit_panel_scatter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fit_panel_scatter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Cesta k souboru field

function cesta_k_souboru_field_Callback(hObject, eventdata, handles)
% hObject    handle to cesta_k_souboru_field (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hints: get(hObject,'String') returns contents of cesta_k_souboru_field as text
%        str2double(get(hObject,'String')) returns contents of cesta_k_souboru_field as a double

function cesta_k_souboru_field_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cesta_k_souboru_field (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Colors popup menu

function colors_popup_Callback(hObject, eventdata, handles)
% hObject    handle to colors_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns colors_popup contents as cell array
%        contents{get(hObject,'Value')} returns selected item from colors_popup
contents = cellstr(get(hObject,'String'));
handles.type_of_color_map = contents{get(hObject,'Value')};
set(handles.Load_text,'string', ['The type of Color map will be ' handles.type_of_color_map '.']);
guidata(hObject, handles);

function colors_popup_CreateFcn(hObject, eventdata, handles)
% hObject    handle to colors_popup (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%% Buffer buttons
function feat_matrix_table_CellSelectionCallback(hObject, eventdata, handles)

%spust se pouze, pokud nco bylo zvoleno, a zrove pokud se to nerovn s
%minulm zvolenm
% con = ;
if ~isempty(eventdata.Indices) && ~(all([1; eventdata.Indices(1,2)] == handles.buffer(:,end)))
selection = eventdata.Indices(1,2);
% informan text o zvolenm sloupci ve feat_matrix
set(handles.Load_text,'string', handles.feature_labels{1,selection});
selection = [1; selection];
%pokud je stav buferru 0; 0, znamen to, e je to inicializace a
%vyprzdnme ho, jeliko 0; 0 byla pouita jen kvli podmnkm
if all(handles.buffer(:,1) == 0)
    handles.buffer = [];
end
% zaznamenn aktulnho stavu do bufferu
handles.buffer = [handles.buffer selection];
% informan text o stavu bufferu
set(handles.buffer_table,'Data', handles.buffer);
% zapnut reset button tlatka pokud je vypl
    if strcmp(get(handles.reset_buffer_button, 'Enable'),'off'); 
    set(handles.reset_buffer_button, 'Enable', 'on');
    end
% zapnut backspace_buffer_button tlatka pokud je vypl
    if strcmp(get(handles.backspace_buffer_button, 'Enable'),'off'); 
    set(handles.backspace_buffer_button, 'Enable', 'on');
    end
guidata(hObject, handles);
handles = checkButtons(handles);
end
    function feat_matrix_table_ButtonDownFcn(hObject, eventdata, handles)

        
function labels_table_CellSelectionCallback(hObject, eventdata, handles)
%spust se pouze, pokud nco bylo zvoleno, a zrove pokud se to nerovn s
%minulm zvolenm
% con = ;
if ~isempty(eventdata.Indices) && ~(all([0; eventdata.Indices(1,2)] == handles.buffer(:,end)))
selection = eventdata.Indices(1,2);
% informan text o zvolenm sloupci v labels
set(handles.Load_text,'string', handles.labels_names{1,selection});
selection = [0; selection];
%pokud je stav buferru 0; 0, znamen to, e je to inicializace a
%vyprzdnme ho, jeliko 0; 0 byla pouita jen kvli podmnkm
if all(handles.buffer(:,1) == 0)
    handles.buffer = [];
end
% zaznamenn aktulnho stavu do bufferu
handles.buffer = [handles.buffer selection];
% informan text o stavu bufferu
set(handles.buffer_table,'Data', handles.buffer);
% zapnut reset button tlatka pokud bylo vypnuto
    if strcmp(get(handles.reset_buffer_button, 'Enable'),'off'); 
    set(handles.reset_buffer_button, 'Enable', 'on');
    end
% zapnut backspace_buffer_button tlatka pokud bylo vypnuto
    if strcmp(get(handles.backspace_buffer_button, 'Enable'),'off'); 
    set(handles.backspace_buffer_button, 'Enable', 'on');
    end
guidata(hObject, handles);
handles = checkButtons(handles);
end
    function labels_table_ButtonDownFcn(hObject, eventdata, handles)

        
function buffer_table_CellSelectionCallback(hObject, eventdata, handles)
if (~isempty(eventdata.Indices)) && (~isempty(handles.buffer))
selection = eventdata.Indices;
% informan text o zvolenm sloupci v labels
switch selection(1,1)
    case 1
        if handles.buffer(1,selection(1,2)) == 1
        set(handles.Load_text,'string', 'feat_matrix');
        else
        set(handles.Load_text,'string', 'labels');            
        end        
    case 2
        if handles.buffer(1,selection(1,2)) == 1
        set(handles.Load_text,'string', handles.feature_labels{1,handles.buffer(2,selection(1,2))});
        else
        set(handles.Load_text,'string', handles.labels_names{1,handles.buffer(2,selection(1,2))});            
        end
end
guidata(hObject, handles);
end
    function buffer_table_ButtonDownFcn(hObject, eventdata, handles)

        
function reset_buffer_button_Callback(hObject, eventdata, handles)
% przdn buffer pro tabulku
handles.buffer = [];
set(handles.buffer_table,'Data', handles.buffer);
% informace pro usera
set(handles.Load_text,'string', 'Buffer is empty.');
%vypnut tlatek
set(handles.reset_buffer_button, 'Enable', 'off');
set(handles.backspace_buffer_button, 'Enable', 'off');
%naplnn bufferu nulama kvli podmnkm
handles.buffer = [0; 0];
guidata(hObject, handles);
handles = checkButtons(handles);


function backspace_buffer_button_Callback(hObject, eventdata, handles)
if ~isempty(handles.buffer)
    handles.buffer(:,size(handles.buffer,2)) = [];
    set(handles.Load_text,'string', 'Last record was removed.');
    set(handles.buffer_table,'Data', handles.buffer);    
end

if isempty(handles.buffer)
    set(handles.Load_text,'string', 'Buffer is empty.');
    set(handles.backspace_buffer_button, 'Enable', 'off');
    set(handles.reset_buffer_button, 'Enable', 'off');    
    handles.buffer = [0; 0];
end
guidata(hObject, handles);
handles = checkButtons(handles);



%% Save button
% --- Executes on button press in save_button.
function save_button_Callback(hObject, eventdata, handles)
% zskn handles na vechny potomky panelu, kde je osa
CHILDREN = get(handles.my_panel,'children');
% nalezen vech objekt s typem axes
CURRAXES=findobj(CHILDREN,'Type','axes');

% vytvoen novho figure a zkoprovn os do nj
NEWFIGURE = figure;
copyobj(CURRAXES, NEWFIGURE);

% nastaven vhodnho vstupnho formtu
set(NEWFIGURE,'PaperOrientation','landscape');

set(NEWFIGURE,'PaperUnits','normalized');

set(NEWFIGURE,'PaperPosition', [0 0 1 1]);

% user si vybira misto pro ulozeni
[filename, pathname, filterindex] = uiputfile( ...
{'*.fig','MATLAB Figure (*.fig)';...
 '*.jpeg','JPEG (*.jpeg)';...
 '*.png','PNG (*.png)';...
 '*.bmp','BMP (*.bmp)';...
 '*.tiff','TIFF (*.tiff)';...
 '*.tiffn','TIFF not compressed (*.tiffn)';...
 '*.pdf','PDF (*.pdf)';...
 '*.eps','EPS,black&white,level3 (*.eps)';...
 '*.epsc','EPS,color,level3 (*.epsc)';...
 '*.eps2','EPS,black&white,level2 (*.eps2)';...
 '*.epsc2','EPS,color,level2 (*.epsc2)';...
 %'*.svg','SVG (*.svg)';...
 '*.ps','PS,black&white,level3 (*.ps)';...
 '*.psc','PS,color,level3 (*.psc)';...
 '*.ps2','PS,black&white,level2 (*.ps2)';...
 '*.psc2','PS,color,level2 (*.psc2)'},...
 'Save as');
if isequal(filename,0) || isequal(pathname,0)
   set(handles.Load_text,'string', 'No file was saved.');
else
    set(handles.Load_text,'string',...
        ['The file was saved as: ',fullfile(pathname,filename)]);
    
    % uloen danho figure
    saveas(NEWFIGURE, fullfile(pathname,filename));
end

close(NEWFIGURE);

guidata(hObject, handles);



%% ERROR MESSAGE CONTROLL
%  *********************************
%% checkLoadWarning
function checkLoadWarning()
% hled vskyt warning s id :load: - chyba v natn dat
% lastwarn pracuje s njakmi internmy promnnmi, kter 
% nejsou ovlivnny GUI 
[msgstr, msgid] = lastwarn;
if ~isempty(strfind(msgid, 'MATLAB:load:'))
    warndlg(msgstr,'Warning - Loading data');
    error(msgstr);
end



%% checkButtons 
% povolovn a zakazovn tlatek
function handles = checkButtons(handles)
if all((handles.buffer(:,end)) == 0)
    % po RESETU nebo uplnem smazanim BACKSPACE - ve se vypne, nebo po
    % naten
    
    % PP plot
    set(handles.pp_plot_button, 'Enable', 'off');
    set(handles.pp_norm_toggle, 'Enable', 'off');
    set(handles.pp_regline_toggle, 'Enable', 'off');   
    
    % QQ plot
    set(handles.qq_plot_button, 'Enable', 'off');
    set(handles.qq_norm_toggle, 'Enable', 'off');
    set(handles.qq_regline_toggle, 'Enable', 'off');
    
    % Boxplot
    set(handles.box_plot_button, 'Enable', 'off');
    set(handles.labels_box_toggle, 'Enable', 'off');
    set(handles.norm_box_toggle, 'Enable', 'off');
    set(handles.num_box_toggle, 'Enable', 'off');
    
    % Histogram
    set(handles.histogram_button, 'Enable', 'off');
    set(handles.histogram_bins_field, 'Enable', 'off');
    set(handles.histogram_norm_toggle, 'Enable', 'off');
    set(handles.histogram_bins_text, 'Enable', 'off');
        
    % Kernel density estimation
    set(handles.kernel_density_button, 'Enable', 'off');  
    set(handles.kernel_values_toggle, 'Enable', 'off');  
    set(handles.kernel_norm_toggle, 'Enable', 'off');  
    
    % Scatter plot
    set(handles.scatter_plot_button, 'Enable', 'off');
    set(handles.reg_line_toggle_scatter, 'Enable', 'off'); 
    set(handles.normalize_toggle_scatter, 'Enable', 'off'); 
    set(handles.fit_panel_scatter, 'Enable', 'off'); 
    set(handles.intervals_panel_scatter, 'Enable', 'off'); 
    set(handles.radio2_verze_scatter, 'Enable', 'off'); 
    set(handles.radio1_verze_scatter, 'Enable', 'off');
    set(handles.fit_text_scatter, 'Enable', 'off');
    set(handles.interval_text_scatter, 'Enable', 'off');
    
    % Reset buttons
    set(handles.reset_buffer_button, 'Enable', 'off');
    set(handles.backspace_buffer_button, 'Enable', 'off');
    
    % Colors buttons
    set(handles.colors_popup, 'Enable', 'off');
    set(handles.colors_text, 'Enable', 'off');
    
    % Save button
    set(handles.save_button, 'Enable', 'off');  
    
else
    % pro scatter diagram je vyjmka
    switch mod(size(handles.buffer,2),2)
        % jinak se zjist, zda je poet sloupc v bufferu sud/lich
        case 0
        % korelan diagram bude vykreslen pouze pokud jsou
        % vechny labely stejn    
        if size(handles.LabelIndex,1) == 1            
            set(handles.scatter_plot_button, 'Enable', 'on');
            set(handles.reg_line_toggle_scatter, 'Enable', 'on'); 
            set(handles.normalize_toggle_scatter, 'Enable', 'on'); 
            set(handles.fit_panel_scatter, 'Enable', 'on'); 
            set(handles.intervals_panel_scatter, 'Enable', 'on'); 
            set(handles.radio2_verze_scatter, 'Enable', 'on'); 
            set(handles.radio1_verze_scatter, 'Enable', 'on');
            set(handles.fit_text_scatter, 'Enable', 'on');
            set(handles.interval_text_scatter, 'Enable', 'on');
        end
        otherwise
            set(handles.scatter_plot_button, 'Enable', 'off');
            set(handles.reg_line_toggle_scatter, 'Enable', 'off'); 
            set(handles.normalize_toggle_scatter, 'Enable', 'off'); 
            set(handles.fit_panel_scatter, 'Enable', 'off'); 
            set(handles.intervals_panel_scatter, 'Enable', 'off'); 
            set(handles.radio2_verze_scatter, 'Enable', 'off'); 
            set(handles.radio1_verze_scatter, 'Enable', 'off');
            set(handles.fit_text_scatter, 'Enable', 'off');
            set(handles.interval_text_scatter, 'Enable', 'off');
    end
            % jinak se vechno zapne            
            
            % PP plot
            set(handles.pp_plot_button, 'Enable', 'on');
            set(handles.pp_norm_toggle, 'Enable', 'on');
            set(handles.pp_regline_toggle, 'Enable', 'on');
            
            % QQ plot
            set(handles.qq_plot_button, 'Enable', 'on');
            set(handles.qq_norm_toggle, 'Enable', 'on');
            set(handles.qq_regline_toggle, 'Enable', 'on');
            
            % Boxplot
            set(handles.box_plot_button, 'Enable', 'on');
            set(handles.labels_box_toggle, 'Enable', 'on');
            set(handles.norm_box_toggle, 'Enable', 'on');
            set(handles.num_box_toggle, 'Enable', 'on');
            
            % Histogram
            set(handles.histogram_button, 'Enable', 'on');
            set(handles.histogram_bins_field, 'Enable', 'on');
            set(handles.histogram_norm_toggle, 'Enable', 'on');
            set(handles.histogram_bins_text, 'Enable', 'on');            
            
            % Kernel density estimation
            set(handles.kernel_density_button, 'Enable', 'on');
            set(handles.kernel_values_toggle, 'Enable', 'on');  
            set(handles.kernel_norm_toggle, 'Enable', 'on');
            
             % Colors buttons
            set(handles.colors_popup, 'Enable', 'on');
            set(handles.colors_text, 'Enable', 'on');   
            
            % Save button
            set(handles.save_button, 'Enable', 'on');   
    
end
