function [i] = PlotHistogram(data,feature_labels,LabelIndex,normalize,choose_bins,type_of_color_map)
%% Histogram
% buffer - vstupn data
% choose_bins je tady oeten na errors
% type_of_color_map bude mt omezen vstup, nebde moct nastanout error
ERROR = false;
%% Test na chybu v choose_bins
if isnan(str2double(choose_bins))
    switch strcmp(choose_bins,'sqrt')
        case false
        ERROR = true;
        message = ['The only valid string is sqrt - the number of bins is than sqrt(number of rows). ' choose_bins ' is not valid string.'];
%         message = ['Jedin platn etzec je sqrt - poet binu je pak sqrt(pocet radku). ' choose_bins ' nen platn etzec.'];
        otherwise
        % zachov se to, vstup je sqrt
    end
else 
    % nad daty se provol fce pro zjitn velikost dk
    % z tto matice se udl min
    % unique ur pouze jedno slo
    % pokud je choose_bins vt ne toto slo, tak to nen povoleno
    minimum_bins = unique(min(cellfun(@(c) size(c,1), data)));
    switch str2double(choose_bins) > minimum_bins
        case true
        ERROR = true;
        message = ['The number of bins you choose (' num2str(choose_bins) ') is too big. The maximum is ' num2str(minimum_bins) '.'];
%         message = ['Zvolen poet bin ' num2str(choose_bins) ' je pli velk. Maximum je ' num2str(minimum_bins) '.'];
        otherwise
        % choose_bins je men, je to dobr
    end
end

if ERROR
    warndlg(message,'Warning - Histogram')
    warning(message);
    error(message);
end
%% ---------------------------

%% Zskn mapy barev
num_of_colors = size(data,1)*size(data,2);
if num_of_colors == 1;
    map = [rand(1) rand(1) rand(1)];
else
    map = brewermap(num_of_colors,type_of_color_map);
end

% przdn buka kvli zamezen cyklickmu zvtovn velikosti
mapa = cell(size(data,1),size(data,2));
% barvy jsou vloeny do bunk, aby se pak snze vybraly pi vykreslovn
count = 1;
for i = 1:size(data,2)
% jede se po sloupcch a v kadm sloupci se pak projedou vechny dky
    for j = 1:size(data,1)
        mapa{j,i} = map(count,:);
        count = count + 1;
    end
end
%% ---------------------------

%% Vykreslen hodnot z buky data
%vykresluje se dkovnm
Feature_label = cell(size(data,1),size(data,2));
for i = 1:size(data,2)
    for j = 1:size(data,1)
        % test zda dana buka je slo nebo NaN anebo zda se tam vyskytuje
        % pouze jedno slo (patn se pak vzkresluje graf
        if ~any(isnan(data{j,i})) && (size(unique(data{j,i}),1) ~= 1)
        % poet binu dle potu dk v danm vykreslen
        if strcmp(choose_bins,'sqrt')
            numBins = fix(sqrt(size(data{j,i},1)))+1;
        else
            numBins = str2double(choose_bins);
        end
        %vbr konkrtn barvy
        col = mapa{j,i};
        if (normalize)
            edge_color_change = 'none';
        else
            edge_color_change = col;
        end
        Feature_label{j,i} = [feature_labels{1,i} ' (' LabelIndex{j,1} ') '];
        histf(data{j,i},numBins,'facecolor',col,'facealpha',0.5,'edgecolor',edge_color_change);
        hold on;
        else
            switch any(isnan(data{j,i}))
                case true
                    % buka je NaN
%                     message = [...
%                         'Buka (' num2str(j) ',' num2str(i) ')-'...
%                         feature_labels{1,i} '(' LabelIndex{j,1} ') '...
%                         'm hodnotu NaN a byla peskoena.'];
                    message = [...
                        'The cell (' num2str(j) ',' num2str(i) ')-'...
                        feature_labels{1,i} '(' LabelIndex{j,1} ') '...
                        'was NaN and had to be skipped.'];
                case false
                    % buka m pouze jedno slo, a v takovm ppad to
                    % rozhazuje graf z neznmho dvodu
%                     message = [...
%                         'Buka (' num2str(j) ',' num2str(i) ')-'...
%                         feature_labels{1,i} '(' LabelIndex{j,1} ') '...
%                         'm pouze hodnotu ' num2str(unique(data{j,i})) ...
%                         ' a byla peskoena z technickch dvod.'];
                    message = [...
                        'The cell (' num2str(j) ',' num2str(i) ')-'...
                        feature_labels{1,i} '(' LabelIndex{j,1} ') '...
                        'cointains only one number: ' num2str(unique(data{j,i})) ...
                        ', and had to be skipped becouse of technical issues.'];
            end
            warning(message);
        end
    end
end
%% ----------------------------

%% Legendy a osy
% maxima a minima X jsou zmnny o 1/10 rozsahu danho grafu
% u y je ymnno jen maximum
my_y = get(gca,'YLim');
set(gca,'YLim',[my_y(1,1) my_y(1,2)+range(my_y)/10]);

my_x = get(gca,'XLim');
set(gca,'XLim',[(my_x(1,1)-range(my_x)/10) (my_x(1,2)+range(my_x)/10)]);

% ----------------------------
% pidn przdnho pole kvli dal funkci, kter intern ad data do
Feature_label{j+1,i+1} = [];
% vymazani prazdnych bunek z Feature_label a zarove seazen za sebe
empty = find(cellfun(@isempty,Feature_label));
Feature_label(empty) = [];
% pokud jsou TAGY stejn, tak odstranme teky, kter jsou zbyten, nejde
% je odstranit v jin fci, jeliko na jejich ptomnosti jsou funkn
% zvisl jin promnn, v ppad legend je to u jedno
% podmnka je dvojnsobn pro jistotu
if strcmp(LabelIndex{1,1},'.') && (size(LabelIndex,1) == 1)
Feature_label = strrep(Feature_label,' (.)', '');
end
legend(Feature_label,'location','NE');
% ----------------------------
% Nzvy
ylabel('Count');
title('Histogram');
% pokud je vykreslen jen jeden histogram, nzev osy X mu bude odpovdat,
% pokud ne, ponese nzev 'Data!
if size(Feature_label,2) ~= 1
    XLABEL = 'Data';
else
    XLABEL = Feature_label{1,1};
end

if normalize
    XLABEL = [XLABEL '(normalized)'];
end
xlabel(XLABEL);
grid on;
hold off;