function [i] = KernelDensityEstimation(buffer,data,feature_labels,plotValues,LabelIndex,normalize,type_of_color_map)
% buffer kvli velikosti
% data jsou data ovlivnn bufferem (jakoby msto feat_matrix)
% plot values - zda chci tisknout data
% feature_labels pro nov hodnoty
% LabelIndex - kvli tipm vykreslovn
% normalize - kvli informaci pro vykreslovn os

% i(nhodn promnn) je kvli funknosti s handles

% horn a doln hranice
lowLevel = 1; 
highLevel = size(buffer,2);


%% Vytvoen databze tip ar
LS ={'-' '--' ':' '-.' '+' 'o' '*' '.' 'x' 's' 'd' '^' 'v' '>' '<' 'p' 'h'};
% pokud je pouito vce sloupc, ne je poet tip ar, zanou se
% jednotliv tipy ar zase opakovat
if ((highLevel - lowLevel)+1) > size(LS,2)
    % poet label
    Size = (highLevel - lowLevel)+1;
    % zbytek po dlen
    modulo = mod(Size,size(LS,2));
    % nsobek
    multiplier = fix(Size/size(LS,2));
    
    if modulo ~= 0
        multiplier = multiplier + 1;
    end
    
    % inicializace przdn buky
    temp = cell(1,multiplier);
    for i = 0:multiplier-1
        for j = 1:size(LS,2)
            % naplnn buky opakujcmi se vzory
            temp{1,j+(i*size(LS,2))} = LS{1,j};
        end
    end
    LS = temp;    
end

%% Vytvoen mapy barev
% vhodn vbr palety barev dle potu kivek
if ((highLevel-lowLevel)+1)*size(LabelIndex,1) ~= 1
    map = brewermap(size(data,1)*((highLevel-lowLevel)+1),type_of_color_map);
else
    map = [rand(1) rand(1) rand(1)];
end
% przdn buka kvli zamezen cyklickmu zvtovn velikosti
mapa = cell(size(data,1),((highLevel-lowLevel)+1));
% barvy jsou vloeny do bunk, aby se pak snze vybraly pi vykreslovn
count = 1;
for i = 1:((highLevel-lowLevel)+1)
% jede se po sloupcch a v kadm sloupci se pak projedou vechny dky
    for j = 1:size(data,1)
        mapa{j,i} = map(count,:);
        count = count + 1;
    end
end

%% Vykresleni jdrovch odhad
% Vykreslen probh po nejdve kad sloupec a v nm vechny dky
% index odpovd poad danho tagu
index = 1;
for i = lowLevel:highLevel
    for j = 1:size(LabelIndex,1)
        % vechny buky se NaN budou peskoeny
        if isempty(find( isnan(data{j,i}) == 1 ))
        % priprava tagu pro legendu
        Feature_label{j,i} = [num2str(index) ' ' feature_labels{1,i} ' (' LabelIndex{j,1} ') '];
        %
        [F{j,i}, X{j,i}] = ksdensity(data{j,i},'kernel', 'normal', 'npoints', 100);
        plot(X{j,i}, F{j,i},LS{(i-lowLevel)+1},'color',mapa{j,((i-lowLevel)+1)},'LineWidth',2);
        % nalezen maxima kvli limitnm hodnotm osy y
        switch index
            case 1
            MAX.Y = max(F{j,i});
            MAX.X = max(X{j,i});
            MIN.Y = min(F{j,i});
            MIN.X = min(X{j,i});
            otherwise
                if MAX.Y < max(F{j,i})
                MAX.Y = max(F{j,i});
                end
                if MAX.X < max(X{j,i})
                MAX.X = max(X{j,i});
                end
                if MIN.Y > min(F{j,i})
                MIN.Y = min(F{j,i});
                end
                if MIN.X > min(X{j,i})
                MIN.X = min(X{j,i});
                end
        end;
        hold on;
        index = index + 1;
        else
%         message = ['Byly preskoceny bunky: data(' num2str(j) ',' num2str(i) ') = ' ... 
%             feature_labels{1,i} ' - ' LabelIndex{j,1} '.' 'Pro jejich zobrazeni vypnete normalizaci.'];
        message = ['Some cells were skipped: data(' num2str(j) ',' num2str(i) ') = ' ...
            feature_labels{1,i} ' - (' LabelIndex{j,1} ') -> For their visualization turn off the normalization.'];
        warning(message);
        end
    end
end

%% Kontrola na NaN
outcome = 0;
for j = 1:size(data,1)
    % pevod dku v buc na matici
    checkmatrix = cell2mat(data(j,:));
    % pokud je nkde v tom sloupci NaN, tak bude zrovna sloupec 1
    row_bool_vect = any(isnan(checkmatrix));
    %pokud by tam byly sam NaN - je to patn, pokud aspo jedna nula = 0
    outcome = outcome + double(all(row_bool_vect));
end

if outcome == size(data,1)
% buka pak obsahuje sam NaN a to je patn
% message_error = 'Zvolen data obsahuj pouze NaN. Nelze vykreslovat. Vypte normalizaci.';
message_error = 'The chosen data contain only NaN. Turn off the normalization. Visualization of the Kernel density estimation plot is not posibble.';
warndlg(message_error,'Warning - Kernel Density Estimation');
warning(message_error);
error(message_error);
end

% nastaven maxima jako MAX.Y + 5% z rozsahu
MAX.Y = MAX.Y + ((MAX.Y-MIN.Y)*0.05);
% nastaven absolutnho minima jako MIN.Y + 5% z rozsahu
MIN.Y = MIN.Y - ((MAX.Y-MIN.Y)*0.05);
%% handle na nynj osu - o jako odhady
o = gca;



if plotValues
%% Vpoet vhodn limitn hodnoty min Y
% min-y odpovd 1/10 = 0.1 pvodnho rozsahu hodnot
% minimum osy y se absolutn zvyuje vdy pi nsobku 3 - itelnost 
index = index - 1;
if mod(index,4) == 0
    ratio = (index /4)*0.1;
else
    ratio = (fix(index /4) + 1)*0.1;
    % je poteba upravit index, kter je dle pouit na vpoet y pozic
    % jednotlivch dat
    index = (fix(index /4) + 1)*4;
end
% pro maximln rove y je nechno jet jist msto pro pehlednost
MIN.Y = MIN.Y - ((MAX.Y-MIN.Y)*ratio);

%% Vykreslen pvodnch dat    
% index odpovd poad danho tagu
% provd se upln ten stejn for cyklus.
% tindex - text index je pozice na y ose, je to rozdlen po 20%, jakmile
tindex = MIN.Y/index;
% nyn index ji figuruje jako tag pro jednotliv body a ry
index = 1;
for i = lowLevel:highLevel
    for j = 1:size(LabelIndex,1)
        % vechny buky se NaN budou peskoeny
        if isempty(find( isnan(data{j,i}) == 1 ))
        text(data{j,i},ones(size(data{j,i},1),1)*(index*(tindex-tindex/10)),num2str(index),'color',mapa{j,((i-lowLevel)+1)},'FontSize',10);
        hold on;
        index = index + 1;
        else
%         message = ['Nebyly vykresleny data pro: data(' num2str(j) ',' num2str(i) ') = ' ... 
%             feature_labels{1,i} ' - ' LabelIndex{j,1} '.' 'Pro jejich zobrazeni vypnete normalizaci.'];
        message = ['Data is some cells were not drawn: data(' num2str(j) ',' num2str(i) ') = ' ... 
            feature_labels{1,i} ' - (' LabelIndex{j,1} ') -> For their visualization turn off the normalization.'];
        warning(message);
        end
    end
end
end



%% Legenda a osy
ylim([MIN.Y MAX.Y]);
xlim([MIN.X MAX.X]);
% pidn przdnho pole kvli dal funkci, kter intern ad data do
Feature_label{j+1,i+1} = [];
% vymazani prazdnych bunek z Feature_label a zarove seazen za sebe
empty = find(cellfun(@isempty,Feature_label));
Feature_label(empty) = [];
if strcmp(LabelIndex{1,1},'.') && (size(LabelIndex,1) == 1)
Feature_label = strrep(Feature_label,' (.)', '');
end
legend(o,Feature_label,'location','NE');

title('Kernel density estimation');
if normalize
    xlabel('Normalized data');
else
    xlabel('Data');
end
ylabel('Probability density function');



grid on;
%axis tight;
hold off;
