function  [FINAL_1D_MATRIX, FINAL_1D_TAGS] = PopisneStatistiky(data,LabelIndex)
% feat_matrix - cel vstupn matice
% TAGS - sloupcov vektro vyjmut z filu labels (je zkontrolovan a je
% pouze char) - TAGS mus mt pouze jeden sloupec!
% vstup
% FINAL_1D_MATRIX - matice, kter zohleduje rzn tagy z labels - napklad pro
% zdrav i nemocn pacienty vypot vdy 1D statistiky
% FINAL_1D_TAGS - sloupcov vektor odpovdajc nzvm statistik + ke
% kadmu nzvu je pedlen vhodn label z TAGS
% hodnoty nejde normalizovat - je to nesmysl pak z nich dlat 1D statistiku
% Statistika se dl z CEL matice, bez ohledu na stav bufferu
% pracuje s funkcemi:
% *GetLabelIndex
% *LoadMatrix2Cell
%% popisne statistiky
Statistiky1D = {'Mean',         ...
                'Range',        ...
                'Median',       ...
                'Variance',     ...
                'Std',          ...
                'Q025',         ...
                'Q25',          ...
                'Q50',          ...
                'Q75',          ...
                'Q975',         ...
                'IQR'
                };
Statistiky1D = Statistiky1D.';

%% Vypotn popisnch statistik pro data
ONE_D_MATRIX = cell(size(data,1),1);
for j = 1:size(data,1)
temp_matrix = cell2mat(data(j,:));
PopisnaMatice = zeros(size(Statistiky1D,1), size(temp_matrix,2));

%Plnn matice kde pro i-ty sloupec jsou postupn vysleny jednotliv
%statistiky
for i = 1 : size(temp_matrix,2)
    %1 Mean(i)
    x = 1;
    PopisnaMatice(x,i) = mean(temp_matrix(:,i));
    
    %2 Range(i)
    x = x+1;
    PopisnaMatice(x,i) = max(temp_matrix(:,i)) - min(temp_matrix(:,i));
    
    %3 Median(i)
    x = x+1;
    PopisnaMatice(x,i) = median(temp_matrix(:,i));
    
    %4 Variance(i)
    x = x+1;
    PopisnaMatice(x,i) = var(temp_matrix(:,i));
    
    %5 Std(i)
    x = x+1;
    PopisnaMatice(x,i) = std(temp_matrix(:,i));
    
    %6 Q025(i)
    x = x+1;
    PopisnaMatice(x,i) = quantile(temp_matrix(:,i), 0.025);
    
    %7 Q25(i)
    x = x+1;
    PopisnaMatice(x,i) = quantile(temp_matrix(:,i), 0.25);
    
    %8 Q50(i)
    x = x+1;
    PopisnaMatice(x,i) = quantile(temp_matrix(:,i), 0.50);
    
    %9 Q75(i)
    x = x+1;
    PopisnaMatice(x,i) = quantile(temp_matrix(:,i), 0.75);
    
    %10 Q975(i)
    x = x+1;
    PopisnaMatice(x,i) = quantile(temp_matrix(:,i), 0.975);
    
    %11 IQR(i)
    x = x+1;
    PopisnaMatice(x,i) = iqr(temp_matrix(:,i));
end

% jednotliv vybran matice jsou vloeny do buek v druhm sloupci,
% podle toho kolikje rznch tag v labels, tak tolik bude matic
% pot se 1D statistika z kadho sloupce size(TAG)*, podmnka je
% tu kvli tomu, e v ppad totonch tag jsou vstupem labelIndex{1,1}
% teky a to nepotebujeme zobrazovat, ovem v ppad TAGS = 'HC', kdy
% jsou vechyn stejn v jednom sloupci, tak se zobraz u nich 'HC'
if ~strcmp(LabelIndex{1,1},'.')
    ONE_D_MATRIX{j,1} = strcat([LabelIndex{j,1} '-'],Statistiky1D);
else
    ONE_D_MATRIX{j,1} = Statistiky1D;
end

ONE_D_MATRIX{j,2} = PopisnaMatice;
end
% transformace ONE_D_MATRIX do jedne vsledn buky
FINAL_1D_TAGS = [];
for i = 1:size(ONE_D_MATRIX,1)
    FINAL_1D_TAGS = [FINAL_1D_TAGS; ONE_D_MATRIX{i,1};];
end

FINAL_1D_MATRIX = [];
for i = 1:size(ONE_D_MATRIX,1)
    FINAL_1D_MATRIX = [FINAL_1D_MATRIX; ONE_D_MATRIX{i,2};];
end









